import{s as ht,n as _t,o as bt}from"../chunks/scheduler.c57aa7ef.js";import{S as Ft,i as xt,g as s,s as n,r as f,A as vt,h as i,f as r,c as a,j as x,u as c,x as p,k as v,y as t,a as d,v as u,d as g,t as h,w as _}from"../chunks/index.394f8801.js";import{D as M}from"../chunks/Docstring.46378b0f.js";import{H as Ke,E as Tt}from"../chunks/EditOnGithub.157fddbf.js";function yt(Je){let T,me,le,pe,k,fe,q,Xe='<a href="https://huggingface.co/papers/2405.03003" rel="nofollow">FourierFT</a> is a parameter-efficient fine-tuning technique that leverages Discrete Fourier Transform to compress the model’s tunable weights. This method outperforms LoRA in the GLUE benchmark and common ViT classification tasks using much less parameters.',ce,D,Ye="FourierFT currently has the following constraints:",ue,P,Ze="<li>Only <code>nn.Linear</code> layers are supported.</li> <li>Quantized layers are not supported.</li>",ge,E,et="If these constraints don’t work for your use case, consider other methods instead.",he,A,tt="The abstract from the paper is:",_e,N,rt="<p>Low-rank adaptation (LoRA) has recently gained much interest in fine-tuning foundation models. It effectively reduces the number of trainable parameters by incorporating low-rank matrices A and B to represent the weight change, i.e., Delta W=BA. Despite LoRA’s progress, it faces storage challenges when handling extensive customization adaptations or larger base models. In this work, we aim to further compress trainable parameters by enjoying the powerful expressiveness of the Fourier transform. Specifically, we introduce FourierFT, which treats Delta W as a matrix in the spatial domain and learns only a small fraction of its spectral coefficients. With the trained spectral coefficients, we implement the inverse discrete Fourier transform to recover Delta W. Empirically, our FourierFT method shows comparable or better performance with fewer parameters than LoRA on various tasks, including natural language understanding, natural language generation, instruction tuning, and image classification. For example, when performing instruction tuning on the LLaMA2-7B model, FourierFT surpasses LoRA with only 0.064M trainable parameters, compared to LoRA’s 33.5M.</p>",be,U,Fe,y,R,qe,G,nt='This is the configuration class to store the configuration of a <a href="/docs/peft/main/en/package_reference/fourierft#peft.FourierFTModel">FourierFTModel</a>.',xe,O,ve,l,H,De,Q,at="Creates FourierFT model from a pretrained transformers model.",Pe,K,ot='The method is described in detail in <a href="https://arxiv.org/abs/2405.03003" rel="nofollow">https://arxiv.org/abs/2405.03003</a>.',Ee,J,st="<strong>Attributes</strong>:",Ae,X,it='<li><strong>model</strong> (<a href="https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel" rel="nofollow">PreTrainedModel</a>) — The model to be adapted.</li> <li><strong>peft_config</strong> (<a href="/docs/peft/main/en/package_reference/fourierft#peft.FourierFTConfig">FourierFTConfig</a>): The configuration of the Fourier model.</li>',Ne,$,I,Ue,Y,lt="Deletes an existing adapter.",Re,b,S,Oe,Z,dt="Disable all adapters.",He,ee,mt="When disabling all adapters, the model output corresponds to the output of the base model.",Ie,F,V,Se,te,pt="Enable all adapters.",Ve,re,ft="Call this if you have previously disabled all adapters and want to re-enable them.",We,w,W,ze,ne,ct=`This method merges the Fourier layers into the base model. This is needed if someone wants to use the base
model as a standalone model.`,Be,C,z,je,ae,ut="Set the active adapter(s).",Ge,L,B,Qe,oe,gt=`Gets back the base model by removing all the Fourier modules without merging. This gives back the original base
model.`,Te,j,ye,de,$e;return k=new Ke({props:{title:"FourierFT: Discrete Fourier Transformation Fine-Tuning",local:"fourierft-discrete-fourier-transformation-fine-tuning",headingTag:"h1"}}),U=new Ke({props:{title:"FourierFTConfig",local:"peft.FourierFTConfig",headingTag:"h2"}}),R=new M({props:{name:"class peft.FourierFTConfig",anchor:"peft.FourierFTConfig",parameters:[{name:"peft_type",val:": Union = None"},{name:"auto_mapping",val:": Optional = None"},{name:"base_model_name_or_path",val:": Optional = None"},{name:"revision",val:": Optional = None"},{name:"task_type",val:": Union = None"},{name:"inference_mode",val:": bool = False"},{name:"n_frequency",val:": int = 1000"},{name:"scaling",val:": float = 150.0"},{name:"random_loc_seed",val:": Optional[int] = 777"},{name:"fan_in_fan_out",val:": bool = False"},{name:"target_modules",val:": Optional[Union[list[str], str]] = None"},{name:"exclude_modules",val:": Optional[Union[list[str], str]] = None"},{name:"bias",val:": str = 'none'"},{name:"modules_to_save",val:": Optional[list[str]] = None"},{name:"layers_to_transform",val:": Optional[Union[list[int], int]] = None"},{name:"layers_pattern",val:": Optional[Union[list[str], str]] = None"},{name:"n_frequency_pattern",val:": Optional[dict] = <factory>"},{name:"init_weights",val:": bool = False"}],parametersDescription:[{anchor:"peft.FourierFTConfig.n_frequency",description:`<strong>n_frequency</strong> (<code>int</code>) &#x2014;
Num of learnable frequencies for the Discrete Fourier Transform. &#x2018;n_frequency&#x2019; is an integer that is
greater than 0 and less than or equal to d^2 (assuming the weight W has dimensions of d by d).
Additionally, it is the number of trainable parameters required to update each delta W weight.
&#x2018;n_frequency&#x2019; will affect the performance and efficiency for PEFT. Specifically, it has little impact on
training speed, but higher values of it (typically) result in larger GPU memory costs and better accuracy.
With the same <code>target_modules</code>, the number of parameters of LoRA is (2<em>d</em>r/n_frequency) times that of
FourierFT. The following examples of settings regarding &#x2018;n_frequency&#x2019; can be used as reference for users.
For NLU tasks with the RoBERTa-large model, adopting &#x2018;n_frequency&#x2019;: 1000 can almost achieve similar results
as &#x2018;r&#x2019;: 8 in LoRA. At this time, the number of parameters of LoRA is about 16 times that of FourierFT. For
image classification tasks with Vit-large models, adopting &#x2018;n_frequency&#x2019;: 3000 can almost achieve similar
results as &#x2018;r&#x2019;: 16 in LoRA, where the number of parameters of LoRA is about 11 times that of FourierFT.`,name:"n_frequency"},{anchor:"peft.FourierFTConfig.scaling",description:`<strong>scaling</strong> (<code>float</code>) &#x2014;
The scaling value for the delta W matrix. This is an important hyperparameter used for scaling, similar to
the &#x2018;lora_alpha&#x2019; parameter in the LoRA method. &#x2018;scaling&#x2019; can be determined during the hyperparameter search
process. However, if users want to skip this process, one can refer to the settings in the following
scenarios. This parameter can be set to 100.0 or 150.0 for both RoBERTa-base and RoBERTa-large models
across all NLU (GLUE) tasks. This parameter can be set to 300.0 for both LLaMA family models for all
instruction tuning. This parameter can be set to 300.0 for both ViT-base and ViT-large models across all
image classification tasks.`,name:"scaling"},{anchor:"peft.FourierFTConfig.random_loc_seed",description:`<strong>random_loc_seed</strong> (<code>int</code>) &#x2014;
Seed for the random location of the frequencies, i.e., the spectral entry matrix.`,name:"random_loc_seed"},{anchor:"peft.FourierFTConfig.target_modules",description:`<strong>target_modules</strong> (<code>Union[list[str],str]</code>) &#x2014;
List of module names or regex expression of the module names to replace with FourierFT. For example, [&#x2018;q&#x2019;,
&#x2018;v&#x2019;] or &#x2018;.<em>decoder.</em>(SelfAttention|EncDecAttention).*(q|v)$&#x2018;. Only linear layers are supported.`,name:"target_modules"},{anchor:"peft.FourierFTConfig.exclude_modules",description:`<strong>exclude_modules</strong> (<code>Optional[Union[List[str], str]]</code>) &#x2014;
The names of the modules to not apply the adapter. When passing a string, a regex match will be performed.
When passing a list of strings, either an exact match will be performed or it is checked if the name of the
module ends with any of the passed strings.`,name:"exclude_modules"},{anchor:"peft.FourierFTConfig.fan_in_fan_out",description:`<strong>fan_in_fan_out</strong> (<code>bool</code>) &#x2014;
Set this to True if the layer to replace stores weight like (fan_in, fan_out).`,name:"fan_in_fan_out"},{anchor:"peft.FourierFTConfig.bias",description:`<strong>bias</strong> (<code>str</code>) &#x2014;
Bias type for FourierFT. Can be &#x2018;none&#x2019;, &#x2018;all&#x2019; or &#x2018;fourier_only&#x2019;.`,name:"bias"},{anchor:"peft.FourierFTConfig.modules_to_save",description:`<strong>modules_to_save</strong> (<code>list[str]</code>) &#x2014;
List of modules apart from FourierFT layers to be set as trainable and saved in the final checkpoint. For
example, in Sequence Classification or Token Classification tasks, the final layer <code>classifier/score</code> are
randomly initialized and as such need to be trainable and saved.`,name:"modules_to_save"},{anchor:"peft.FourierFTConfig.layers_to_transform",description:`<strong>layers_to_transform</strong> (<code>Union[list[int],int]</code>) &#x2014;
The layer indexes to transform, is this argument is specified, PEFT will transform only the layers indexes
that are specified inside this list. If a single integer is passed, PEFT will transform only the layer at
this index.`,name:"layers_to_transform"},{anchor:"peft.FourierFTConfig.layers_pattern",description:`<strong>layers_pattern</strong> (<code>Optional[Union[List[str], str]]</code>) &#x2014;
The layer pattern name, used only if <code>layers_to_transform</code> is different to None and if the layer pattern is
not in the common layers pattern. This should target the <code>nn.ModuleList</code> of the model, which is often
called <code>&apos;layers&apos;</code> or <code>&apos;h&apos;</code>.`,name:"layers_pattern"},{anchor:"peft.FourierFTConfig.n_frequency_pattern",description:`<strong>n_frequency_pattern</strong> (<code>dict</code>) &#x2014;
The mapping from layer names or regexp expression to n_frequency which are different from the default
specified. For example, <code>{model.decoder.layers.0.encoder_attn.k_proj: 1000</code>}.`,name:"n_frequency_pattern"},{anchor:"peft.FourierFTConfig.init_weights",description:`<strong>init_weights</strong> (<code>bool</code>) &#x2014;
The initialization of the Fourier weights. Set this to False if the spectrum are initialized to a standard
normal distribution. Set this to True if the spectrum are initialized to zeros.`,name:"init_weights"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/fourierft/config.py#L24"}}),O=new Ke({props:{title:"FourierFTModel",local:"peft.FourierFTModel",headingTag:"h2"}}),H=new M({props:{name:"class peft.FourierFTModel",anchor:"peft.FourierFTModel",parameters:[{name:"model",val:""},{name:"config",val:""},{name:"adapter_name",val:""},{name:"low_cpu_mem_usage",val:": bool = False"}],parametersDescription:[{anchor:"peft.FourierFTModel.model",description:"<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014; The model to be adapted.",name:"model"},{anchor:"peft.FourierFTModel.config",description:'<strong>config</strong> (<a href="/docs/peft/main/en/package_reference/fourierft#peft.FourierFTConfig">FourierFTConfig</a>) &#x2014; The configuration of the FourierFT model.',name:"config"},{anchor:"peft.FourierFTModel.adapter_name",description:"<strong>adapter_name</strong> (<code>str</code>) &#x2014; The name of the adapter, defaults to <code>&quot;default&quot;</code>.",name:"adapter_name"},{anchor:"peft.FourierFTModel.low_cpu_mem_usage",description:`<strong>low_cpu_mem_usage</strong> (<code>bool</code>, <code>optional</code>, defaults to <code>False</code>) &#x2014;
Create empty adapter weights on meta device. Useful to speed up the loading process.`,name:"low_cpu_mem_usage"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/fourierft/model.py#L38",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The FourierFT model.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.nn.Module</code></p>
`}}),I=new M({props:{name:"delete_adapter",anchor:"peft.FourierFTModel.delete_adapter",parameters:[{name:"adapter_name",val:": str"}],parametersDescription:[{anchor:"peft.FourierFTModel.delete_adapter.adapter_name",description:"<strong>adapter_name</strong> (str) &#x2014; Name of the adapter to be deleted.",name:"adapter_name"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/fourierft/model.py#L301"}}),S=new M({props:{name:"disable_adapter_layers",anchor:"peft.FourierFTModel.disable_adapter_layers",parameters:[],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/fourierft/model.py#L237"}}),V=new M({props:{name:"enable_adapter_layers",anchor:"peft.FourierFTModel.enable_adapter_layers",parameters:[],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/fourierft/model.py#L230"}}),W=new M({props:{name:"merge_and_unload",anchor:"peft.FourierFTModel.merge_and_unload",parameters:[{name:"progressbar",val:": bool = False"},{name:"safe_merge",val:": bool = False"},{name:"adapter_names",val:": Optional[list[str]] = None"}],parametersDescription:[{anchor:"peft.FourierFTModel.merge_and_unload.progressbar",description:`<strong>progressbar</strong> (<code>bool</code>) &#x2014;
whether to show a progressbar indicating the unload and merge process`,name:"progressbar"},{anchor:"peft.FourierFTModel.merge_and_unload.safe_merge",description:`<strong>safe_merge</strong> (<code>bool</code>) &#x2014;
whether to activate the safe merging check to check if there is any potential Nan in the adapter
weights`,name:"safe_merge"},{anchor:"peft.FourierFTModel.merge_and_unload.adapter_names",description:`<strong>adapter_names</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
The list of adapter names that should be merged. If None, all active adapters will be merged. Defaults
to <code>None</code>.`,name:"adapter_names"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/fourierft/model.py#L324"}}),z=new M({props:{name:"set_adapter",anchor:"peft.FourierFTModel.set_adapter",parameters:[{name:"adapter_name",val:": str | list[str]"}],parametersDescription:[{anchor:"peft.FourierFTModel.set_adapter.adapter_name",description:"<strong>adapter_name</strong> (<code>str</code> or <code>list[str]</code>) &#x2014; Name of the adapter(s) to be activated.",name:"adapter_name"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/fourierft/model.py#L252"}}),B=new M({props:{name:"unload",anchor:"peft.FourierFTModel.unload",parameters:[],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/fourierft/model.py#L345"}}),j=new Tt({props:{source:"https://github.com/huggingface/peft/blob/main/docs/source/package_reference/fourierft.md"}}),{c(){T=s("meta"),me=n(),le=s("p"),pe=n(),f(k.$$.fragment),fe=n(),q=s("p"),q.innerHTML=Xe,ce=n(),D=s("p"),D.textContent=Ye,ue=n(),P=s("ul"),P.innerHTML=Ze,ge=n(),E=s("p"),E.textContent=et,he=n(),A=s("p"),A.textContent=tt,_e=n(),N=s("blockquote"),N.innerHTML=rt,be=n(),f(U.$$.fragment),Fe=n(),y=s("div"),f(R.$$.fragment),qe=n(),G=s("p"),G.innerHTML=nt,xe=n(),f(O.$$.fragment),ve=n(),l=s("div"),f(H.$$.fragment),De=n(),Q=s("p"),Q.textContent=at,Pe=n(),K=s("p"),K.innerHTML=ot,Ee=n(),J=s("p"),J.innerHTML=st,Ae=n(),X=s("ul"),X.innerHTML=it,Ne=n(),$=s("div"),f(I.$$.fragment),Ue=n(),Y=s("p"),Y.textContent=lt,Re=n(),b=s("div"),f(S.$$.fragment),Oe=n(),Z=s("p"),Z.textContent=dt,He=n(),ee=s("p"),ee.textContent=mt,Ie=n(),F=s("div"),f(V.$$.fragment),Se=n(),te=s("p"),te.textContent=pt,Ve=n(),re=s("p"),re.textContent=ft,We=n(),w=s("div"),f(W.$$.fragment),ze=n(),ne=s("p"),ne.textContent=ct,Be=n(),C=s("div"),f(z.$$.fragment),je=n(),ae=s("p"),ae.textContent=ut,Ge=n(),L=s("div"),f(B.$$.fragment),Qe=n(),oe=s("p"),oe.textContent=gt,Te=n(),f(j.$$.fragment),ye=n(),de=s("p"),this.h()},l(e){const o=vt("svelte-u9bgzb",document.head);T=i(o,"META",{name:!0,content:!0}),o.forEach(r),me=a(e),le=i(e,"P",{}),x(le).forEach(r),pe=a(e),c(k.$$.fragment,e),fe=a(e),q=i(e,"P",{"data-svelte-h":!0}),p(q)!=="svelte-1our0gb"&&(q.innerHTML=Xe),ce=a(e),D=i(e,"P",{"data-svelte-h":!0}),p(D)!=="svelte-7ls0zq"&&(D.textContent=Ye),ue=a(e),P=i(e,"UL",{"data-svelte-h":!0}),p(P)!=="svelte-8km6hk"&&(P.innerHTML=Ze),ge=a(e),E=i(e,"P",{"data-svelte-h":!0}),p(E)!=="svelte-hr8j55"&&(E.textContent=et),he=a(e),A=i(e,"P",{"data-svelte-h":!0}),p(A)!=="svelte-1cwsb16"&&(A.textContent=tt),_e=a(e),N=i(e,"BLOCKQUOTE",{"data-svelte-h":!0}),p(N)!=="svelte-1lxn511"&&(N.innerHTML=rt),be=a(e),c(U.$$.fragment,e),Fe=a(e),y=i(e,"DIV",{class:!0});var we=x(y);c(R.$$.fragment,we),qe=a(we),G=i(we,"P",{"data-svelte-h":!0}),p(G)!=="svelte-1j2s7ln"&&(G.innerHTML=nt),we.forEach(r),xe=a(e),c(O.$$.fragment,e),ve=a(e),l=i(e,"DIV",{class:!0});var m=x(l);c(H.$$.fragment,m),De=a(m),Q=i(m,"P",{"data-svelte-h":!0}),p(Q)!=="svelte-16dbami"&&(Q.textContent=at),Pe=a(m),K=i(m,"P",{"data-svelte-h":!0}),p(K)!=="svelte-1uoo92x"&&(K.innerHTML=ot),Ee=a(m),J=i(m,"P",{"data-svelte-h":!0}),p(J)!=="svelte-1xx6nm4"&&(J.innerHTML=st),Ae=a(m),X=i(m,"UL",{"data-svelte-h":!0}),p(X)!=="svelte-1ffj8s8"&&(X.innerHTML=it),Ne=a(m),$=i(m,"DIV",{class:!0});var Ce=x($);c(I.$$.fragment,Ce),Ue=a(Ce),Y=i(Ce,"P",{"data-svelte-h":!0}),p(Y)!=="svelte-1cw64z1"&&(Y.textContent=lt),Ce.forEach(r),Re=a(m),b=i(m,"DIV",{class:!0});var se=x(b);c(S.$$.fragment,se),Oe=a(se),Z=i(se,"P",{"data-svelte-h":!0}),p(Z)!=="svelte-q60vod"&&(Z.textContent=dt),He=a(se),ee=i(se,"P",{"data-svelte-h":!0}),p(ee)!=="svelte-1ecn6m6"&&(ee.textContent=mt),se.forEach(r),Ie=a(m),F=i(m,"DIV",{class:!0});var ie=x(F);c(V.$$.fragment,ie),Se=a(ie),te=i(ie,"P",{"data-svelte-h":!0}),p(te)!=="svelte-bv5m7u"&&(te.textContent=pt),Ve=a(ie),re=i(ie,"P",{"data-svelte-h":!0}),p(re)!=="svelte-13saw9o"&&(re.textContent=ft),ie.forEach(r),We=a(m),w=i(m,"DIV",{class:!0});var Le=x(w);c(W.$$.fragment,Le),ze=a(Le),ne=i(Le,"P",{"data-svelte-h":!0}),p(ne)!=="svelte-12pgcpt"&&(ne.textContent=ct),Le.forEach(r),Be=a(m),C=i(m,"DIV",{class:!0});var Me=x(C);c(z.$$.fragment,Me),je=a(Me),ae=i(Me,"P",{"data-svelte-h":!0}),p(ae)!=="svelte-8teaja"&&(ae.textContent=ut),Me.forEach(r),Ge=a(m),L=i(m,"DIV",{class:!0});var ke=x(L);c(B.$$.fragment,ke),Qe=a(ke),oe=i(ke,"P",{"data-svelte-h":!0}),p(oe)!=="svelte-1ni5vt4"&&(oe.textContent=gt),ke.forEach(r),m.forEach(r),Te=a(e),c(j.$$.fragment,e),ye=a(e),de=i(e,"P",{}),x(de).forEach(r),this.h()},h(){v(T,"name","hf:doc:metadata"),v(T,"content",$t),v(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(l,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,o){t(document.head,T),d(e,me,o),d(e,le,o),d(e,pe,o),u(k,e,o),d(e,fe,o),d(e,q,o),d(e,ce,o),d(e,D,o),d(e,ue,o),d(e,P,o),d(e,ge,o),d(e,E,o),d(e,he,o),d(e,A,o),d(e,_e,o),d(e,N,o),d(e,be,o),u(U,e,o),d(e,Fe,o),d(e,y,o),u(R,y,null),t(y,qe),t(y,G),d(e,xe,o),u(O,e,o),d(e,ve,o),d(e,l,o),u(H,l,null),t(l,De),t(l,Q),t(l,Pe),t(l,K),t(l,Ee),t(l,J),t(l,Ae),t(l,X),t(l,Ne),t(l,$),u(I,$,null),t($,Ue),t($,Y),t(l,Re),t(l,b),u(S,b,null),t(b,Oe),t(b,Z),t(b,He),t(b,ee),t(l,Ie),t(l,F),u(V,F,null),t(F,Se),t(F,te),t(F,Ve),t(F,re),t(l,We),t(l,w),u(W,w,null),t(w,ze),t(w,ne),t(l,Be),t(l,C),u(z,C,null),t(C,je),t(C,ae),t(l,Ge),t(l,L),u(B,L,null),t(L,Qe),t(L,oe),d(e,Te,o),u(j,e,o),d(e,ye,o),d(e,de,o),$e=!0},p:_t,i(e){$e||(g(k.$$.fragment,e),g(U.$$.fragment,e),g(R.$$.fragment,e),g(O.$$.fragment,e),g(H.$$.fragment,e),g(I.$$.fragment,e),g(S.$$.fragment,e),g(V.$$.fragment,e),g(W.$$.fragment,e),g(z.$$.fragment,e),g(B.$$.fragment,e),g(j.$$.fragment,e),$e=!0)},o(e){h(k.$$.fragment,e),h(U.$$.fragment,e),h(R.$$.fragment,e),h(O.$$.fragment,e),h(H.$$.fragment,e),h(I.$$.fragment,e),h(S.$$.fragment,e),h(V.$$.fragment,e),h(W.$$.fragment,e),h(z.$$.fragment,e),h(B.$$.fragment,e),h(j.$$.fragment,e),$e=!1},d(e){e&&(r(me),r(le),r(pe),r(fe),r(q),r(ce),r(D),r(ue),r(P),r(ge),r(E),r(he),r(A),r(_e),r(N),r(be),r(Fe),r(y),r(xe),r(ve),r(l),r(Te),r(ye),r(de)),r(T),_(k,e),_(U,e),_(R),_(O,e),_(H),_(I),_(S),_(V),_(W),_(z),_(B),_(j,e)}}}const $t='{"title":"FourierFT: Discrete Fourier Transformation Fine-Tuning","local":"fourierft-discrete-fourier-transformation-fine-tuning","sections":[{"title":"FourierFTConfig","local":"peft.FourierFTConfig","sections":[],"depth":2},{"title":"FourierFTModel","local":"peft.FourierFTModel","sections":[],"depth":2}],"depth":1}';function wt(Je){return bt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qt extends Ft{constructor(T){super(),xt(this,T,wt,yt,ht,{})}}export{qt as component};
